/*
*
* Copyright (c) 2005 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Realizing Strategies for Document-Based Web Services With JAX-WS 2.0"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/
import javax.activation.*;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.Source;
import java.io.*;
import javax.xml.ws.BindingProvider;
import com.examples.attachmentservice.clientbindings.*;

public class WSDLClient {
    public static void main(String[] args) {
        try {

			String url = System.getProperty("serviceurl");
            String filename = "Uploadme.doc";
            String xmlfilename = "purchaseorder.xml";
            if (args.length == 3) {
                url = args[0];
                filename = args[1];
                xmlfilename = args[2];
            }
		POService serviceproxy = new POService();

		IPurchaseOrder stub = (IPurchaseOrder) (serviceproxy.getIPurchaseOrderPort());
        ((BindingProvider) stub).getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, url);

        sentAttachmentWithSource(xmlfilename, stub);
	       sendAttachmentWithDataHandler(filename, stub);
     


        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static void sendAttachmentWithDataHandler(String filename, IPurchaseOrder stub) throws Exception {
        DataHandler dh = new DataHandler(new FileDataSource(filename));
        String response = stub.storeDocumentService(dh, filename);
        System.out.println("Response from server " + response);
    }

    private static void sentAttachmentWithSource(String filename, IPurchaseOrder stub) throws Exception {
        Source src = new StreamSource(new File(filename));
        String response = stub.storeDocumentXML(src, filename);
        System.out.println("Response from server " + response);
    }

}
