/*
*
* Copyright (c) 2005 Sun Microsystems, Inc.
* All rights reserved.
* You may not modify, use, reproduce, or distribute this software except in compliance with the terms
* of the License at: http://developer.sun.com/berkeley_license.html
* Author : Sameer Tyagi, Sun Microsystems s.t@sun.com
* "Realizing Strategies for Document-Based Web Services With JAX-WS 2.0"
*  http://java.sun.com/developer/technicalArticles/xml/jaxrpcpatterns
*/

package com.examples.attachmentservice;

import java.rmi.Remote;
import java.rmi.RemoteException;
import javax.activation.DataHandler;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import java.util.Date;
import java.io.*;

@javax.jws.WebService(endpointInterface="com.examples.attachmentservice.IPurchaseOrder")
public class PurchaseOrderService {
 

    /**
     * This method implements a web service that stores any attachment it receives.
     */
    public String storeDocumentService(DataHandler dh, String filename) {
        try {
            System.out.println(" >>>> storeDocumentService storing file to  " + "/" + filename);
            BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream("/" + filename));
            BufferedInputStream in = new BufferedInputStream(dh.getInputStream());

            byte[] buffer = new byte[256];
            while (true) {
                int bytesRead = in.read(buffer);
                if (bytesRead == -1)
                    break;
                out.write(buffer, 0, bytesRead);
            }
            in.close();
            out.close();
        } catch (Exception e) {
            System.out.println(e);
            return e.toString();
        }
        return ("File processes succesfully " + filename + "  " + new Date());
    }


    /**
     * This method implements a web service that stores an XML document it receives.
     */
    public String storeDocumentXML(Source dh, String filename) {

        try {
		   System.out.println(" >>>> storeDocumentXML storing file to  " + "/" + filename);
            TransformerFactory factory = TransformerFactory.newInstance();
            Transformer transformer = factory.newTransformer();
            // also print to console
			File f = new File ("/"+filename);
            transformer.transform(dh, new StreamResult(f));

        } catch (Exception e) {
            System.out.println(e);
        }
         return ("File processes succesfully " + filename + "  " + new Date());
    }



}